(use-modules (gnu)
             (nongnu packages linux)
             (nongnu system linux-initrd)
             (nongnu packages nvidia)
             (nongnu services nvidia)
             (metznet system base-system)
             (gnu packages vim)
             (gnu packages version-control)
             (gnu packages shells))

(operating-system
  (inherit %metznet-base-desktop-system)

  ;; Requires nonfree kernel for intel wifi support
  (kernel linux-6.1)
  (initrd microcode-initrd)
  (firmware (list linux-firmware))
  (host-name "otto")
  (bootloader (bootloader-configuration
                (bootloader grub-efi-bootloader)
                (targets '("/boot/efi"))))
  (services
   (append (list (service nvidia-service-type
                          (nvidia-configuration (modules (list "nvidia"
                                                          "nvidia_uvm"
                                                          "nvidia_drm"
                                                          "nvidia_modeset")))))
           (modify-services %metznet-desktop-services
             (guix-service-type config =>
                                (guix-configuration (inherit config)
                                                    (substitute-urls (append (list
                                                                              "https://substitutes.nonguix.org")
                                                                      %default-substitute-urls))
                                                    (authorized-keys (append (list
                                                                              (plain-file
                                                                               "nonguix-signing-key.pub"
                                                                               "(public-key 
 (ecc 
  (curve Ed25519)
  (q #C1FD53E5D4CE971933EC50C9F307AE2171A2D3B52C804642A7A35F84F3A4EA98#)
  )
 )
"))
                                                                      %default-authorized-guix-keys)))))))
  (swap-devices (list (swap-space
                        (target (file-system-label "otto-swap")))))
  (file-systems (cons* (file-system
                         (device (file-system-label "OTTO-BOOT"))
                         (mount-point "/boot/efi")
                         (type "vfat"))
                       (file-system
                         (device (file-system-label "otto-data"))
                         (mount-point "/")
                         (type "ext4")) %base-file-systems))
  (sudoers-file (plain-file "sudoers"
                            (string-join (list
                                          "root ALL=(ALL:ALL) NOPASSWD:ALL"
                                          "%admin ALL=(ALL:ALL) ALL" "") "\n")))

  (packages (cons* nvidia-driver git neovim %metznet-desktop-packages)))
